# Directory Documentation for `elk`

## Description
This package provides classes used to export diagram with the [Eclipse Layout Kernel (ELK)](https://plantuml.com/elk) layout engine.

## Link
- [PlantUML 'Eclipse Layout Kernel (ELK)' Engine](https://plantuml.com/elk)

## Reference
- [Eclipse Layout Kernel (ELK)](https://eclipse.dev/elk/)
- [ELK Documentation](https://eclipse.dev/elk/documentation.html)

## Credit
- [`elk/proxy`](./proxy/) _(included in PlantUML)_
- :octocat: [eclipse/elk](https://github.com/eclipse/elk)

## See also other engines
- [GraphViz dot](https://plantuml.com/graphviz-dot)
  - [`plantuml/dot`](../dot/)
- [Smetana _(internal port of GraphViz in plantuml)_](https://plantuml.com/smetana02) and :octocat: [plantuml/smetana](https://github.com/plantuml/smetana)
  - [`plantuml/sdot`](../sdot/)
  - [`src/gen`](../../../../gen)
  - [`src/smetana/core`](../../../../smetana/core)
  - [`src/h`](../../../../h)
- [PlantUML Vizjs _(a port to Javascript of GraphViz)_](https://plantuml.com/vizjs)
  - [`plantuml/vizjs`](../vizjs/) _(included in PlantUML)_
  - :octocat: [Plantuml/Vizjs](https://github.com/plantuml/vizjs) _(not included in `plantuml/plantuml`)_